<?php
/**
*
* @package functions_number_of_changed_topics.php
* @version $Id: $
* @copyright (c) 2011 Max Senft
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}


/**
*
* This function will return an array consisting of forum_id as
* array keys and the count of threads with new messages as array values
*
*/
function get_unread_topics_info(&$my_info_array)
{
	global $db, $phpbb_root_path, $phpEx, $template, $config, $user, $auth;
	
	// if user is not logged in
	// OR
	// if the board is not using db to track unreads, just return
	if (!$user->data['is_registered'] || !$config['load_db_lastread'])
	{
		return;
	}

	$sql = 'SELECT t.forum_id, t.topic_id
		FROM ' . TOPICS_TABLE . ' t
		LEFT JOIN ' . FORUMS_TRACK_TABLE . ' ft ON (t.forum_id = ft.forum_id AND ft.user_id = ' . $user->data['user_id'] . ')
		LEFT JOIN ' . TOPICS_TRACK_TABLE . ' tt ON (t.topic_id = tt.topic_id AND tt.user_id = ' . $user->data['user_id'] . ')
		WHERE
		(
			t.topic_last_post_time > tt.mark_time
			OR (tt.mark_time IS NULL AND t.topic_last_post_time > ft.mark_time)
			OR (tt.mark_time IS NULL AND ft.mark_time IS NULL AND  t.topic_last_post_time > ' . $user->data['user_lastmark'] . ')
		)
		AND t.topic_moved_id = 0
		ORDER BY t.forum_id ASC, t.topic_last_post_time DESC';
	
	$field = 'topic_id';
	
	$result = $db->sql_query($sql);
	
	while ($row = $db->sql_fetchrow($result))
    {
		if (!$auth->acl_get('f_list', $row['forum_id']))
        {
			continue;
		}
		
		$cur_forum_id = $row['forum_id'];
		
		if (!isset($my_info_array[$cur_forum_id]))
        {
			$my_info_array[$cur_forum_id] = array(
				'newest_topic' => $row['topic_id'],
				'forum_count'  => 1); 
		}
        else
        {
			$my_info_array[$cur_forum_id]['forum_count']++;
		}
	}
}

?>